#! /bin/bash

if [ -z "$RPM_BUILD_ROOT" -o "$RPM_BUILD_ROOT" = "/" ]; then
	echo "ERROR: no RPM_BUILD_ROOT"
	exit 1
fi

if [ -z "$2" -o "$2" = "/" ]; then
	echo "ERROR: no TARGET_PRFIX"
	exit 1
fi

if [ -z "$1" ]; then
	echo "ERROR: no cpython ver."
	exit 1
fi

CVER=`echo $1 | sed s:"\\."::`
if [ -z "$CVER" ]; then
	echo "ERROR: no cpython ver."
	exit 1
fi

CPYTHON=".cpython-$CVER"

DEL_O1="0"
DEL_O2="0"
USE_O1="0"
USE_O2="0"

idx=0
for option ; do
  idx=$((idx+1))
  if [ $idx = 1 ]; then
    case $option in
    -*) echo "ERROR: no cpython ver."; exit 1
    esac
    continue
  fi
  if [ $idx = 2 ]; then
    case $option in
    -*) echo "ERROR: no TARGET_PRFIX"; exit 1
    esac
    continue
  fi

  case $option in
  -del-O|-del_O|-del-o|-del_o) DEL_O1="1" ;  DEL_O2="1" ;;
  -del-O1|-del_O1|-del-o1|-del_o1) DEL_O1="1" ;;
  -del-O2|-del_O2|-del-o2|-del_o2) DEL_O2="1" ;;
  -use-O|-use_O|-use-o|-use_o) USE_O1="1"; USE_O2="1" ;;
  -use-O1|-use_O1|-use-o1|-use_o1) USE_O1="1" ;;
  -use-O2|-use_O2|-use-o2|-use_o2) USE_O2="1" ;;
  *) echo "ERROR: option=$option"; exit 1 ;;
  esac
done 

cd $RPM_BUILD_ROOT$2

function mv_pyc() {
  pushd $1 >/dev/null

  xf=`ls *.py*`
  echo "$xf" | while read f ; do
    ds=`echo $f | sed s:"$CPYTHON"::`
#    echo "mv $f		--> ../$ds"
    mv $f ../$ds
    if test $? != 0 ; then
      echo "path=$1 (mv $f ../$ds)"
      exit 1
    fi
  done

  popd >/dev/null

  rmdir $1
  if test $? != 0 ; then
    echo "rm $1"
    exit 1
  fi
}

find -type d -iname __pycache__  | while read path ; do
  mv_pyc $path
done

function mv_O1_pyc() {
    ds=`echo $1 | sed s:".opt-1"::`
    if test -f $ds ; then
	rm $ds
    fi
    mv $1 $ds
}

function mv_O2_pyc() {
    ds=`echo $1 | sed s:".opt-2"::`
    if test -f $ds ; then
	rm $ds
    fi
    mv $1 $ds
}

if [ "$USE_O1" = "1" ]; then
  find . -name "*.opt-1.pyc" | while read path ; do
    mv_O1_pyc $path
  done
fi

if [ "$USE_O2" = "1" ]; then
  find . -name "*.opt-2.pyc" | while read path ; do
    mv_O2_pyc $path
  done
fi

if [ "$DEL_O1" = "1" ]; then
  find . -name "*.opt-1.pyc" -exec rm {} \;
fi

if [ "$DEL_O2" = "1" ]; then
  find . -name "*.opt-2.pyc" -exec rm {} \;
fi
